<?php

namespace Ulmus\Query;

class From extends Fragment {

    const SQL_TOKEN = "FROM";
    
    public int $order = -80;

    public array $tables = [];

    public function set(array $tables) : self
    {
        $this->tables = $tables;
        
        return $this;
    }

    public function add(/* array|string */ $table) : self
    {
        foreach((array) $table as $alias => $name) {
            $this->tables[$alias] = $name;
        }

        return $this;
    }

    public function render() : string
    {
        return $this->renderSegments([
            static::SQL_TOKEN, $this->renderTables(),
        ]);
    }

    protected function renderTables() : string
    {
        $list = [];

        foreach((array) $this->tables as $alias => $table) {
            $list[] = ! is_numeric($alias) ? "$table $alias" : $table;
        }

        return implode(", ", $list);
    }
}
