<?php

namespace Ulmus\Query;

use Ulmus\QueryBuilder;

class Set extends Fragment {

    public int $order = 0;
    
    public array $dataset;
    
    public QueryBuilder $queryBuilder;

    public function __construct(QueryBuilder $queryBuilder)
    {
        $this->queryBuilder = $queryBuilder;
    }
    
    public function set(array $dataset) : self
    {
        $this->dataset = $dataset;
        
        return $this;
    }

    public function render() : string
    {                    
        return $this->renderSegments([
            'SET', $this->renderParameterPlaceholders(),
        ]);
    }
    
    public function renderParameterPlaceholders() : string 
    {        
        $keys = [];
        
        foreach($this->dataset as $key =>$value) {
            $this->queryBuilder->addParameter($value, ":v_$key");
            $keys[] = "$key=:v_$key";
        }
        
        return implode(",", $keys);
    }
}